const WxParse = require('../../../wxParse/wxParse.js');
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    bgImg: app.globalData.bgImg,
    goods: [],
    page: 1
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.showLoading({
      title: '加载中',
    })
    wx.request({
      url: app.globalData.ip + '/wisdommining/api/banner/getDistribution',
      method: 'GET',
      header: {
        "content-type": "application/x-www-form-urlencoded",
      },
      data: {},
      success: res => {
        console.log(res)
        wx.hideLoading()
        if (res.data.code == 1) {
          WxParse.wxParse('article', 'html', res.data.value.welfarePhoto, this, 20);
        } else {
          wx.showModal({
            title: '获取数据失败!',
            content: res.data.message,
            showCancel: false,
          })
        }
      }
    })
    this.goodsList()
  },

  goodsList(e) {
    wx.showLoading({
      title: '加载中',
    })
    wx.request({
      url: app.globalData.ip + '/wisdommining/api/goods/getProfitsGoods',
      method: 'GET',
      header: {
        "content-type": "application/x-www-form-urlencoded",
      },
      data: {
        userId: app.globalData.userId,
        page: this.data.page,
        num: 10,
      },
      success: res => {
        console.log(res)
        wx.hideLoading()
        if (res.data.code == 1) {
          let data = res.data.value.records
          if (data != null && data.length > 0) {
            let goods = this.data.goods;
            console.log(goods)
            for (let i = 0; i < data.length; i++) {
              goods.push(data[i]);
            }
            this.setData({
              goods: goods,
              page: this.data.page + 1,
            })
          } else {
            if (this.data.page > 1) {
              wx.showToast({
                title: '暂无更多~',
                icon: 'none',
                duration: 1000,
              })
            }
          }
        } else {
          wx.showModal({
            title: '获取数据失败!',
            content: res.data.message,
            showCancel: false,
          })
        }
      }
    })
  },

  //商品详情
  goodsDetails(e) {
    let id = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: '/pages/goodsDetails/goodsDetails?goodsId=' + id,
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
  * 用户点击右上角分享
  */
  onShareAppMessage: function (e) {
    app.share();
    console.log(e)
    return {
      path: '/pages/index/index?pId=' + app.globalData.userId,
      title: '三品慧采小程序等你来~'
    }
  },
})