const { guessExpressCom, getExpressDetail } = require("../../api/express")
// pages/logistics_details/logistics_details.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    records: [],
    expressComName: [
      "圆通速递",
      "申通快递",
      "极兔速递",
      "中通快递",
      "韵达快递",
      "邮政快递包裹",
      "顺丰速运",
      "京东物流",
      "EMS",
      "邮政电商标快",
      "邮政标准快递",
      "德邦快递",
      "菜鸟速递",
      "德邦",
      "中通快运",
      "安能快运",
      "顺丰快运",
      "韵达快运",
      "跨越速运",
      "京东快运",
      "百世快运",
      "菜鸟速递",
    ],
    currentExpressComIndex: 0,
    expressComs: [
      { name: "圆通速递", code: "yuantong" },
      { name: "申通快递", code: "shentong" },
      { name: "极兔速递", code: "jtexpress" },
      { name: "中通快递", code: "zhongtong" },
      { name: "韵达快递", code: "yunda" },
      { name: "邮政快递包裹", code: "youzhengguonei" },
      { name: "顺丰速运", code: "shunfeng" },
      { name: "京东物流", code: "jd" },
      { name: "EMS", code: "ems" },
      { name: "邮政电商标快", code: "youzhengdsbk" },
      { name: "邮政标准快递", code: "youzhengbk" },
      { name: "德邦快递", code: "debangkuaidi" },
      { name: "菜鸟速递", code: "danniao" },
      { name: "德邦", code: "debangwuliu" },
      { name: "中通快运", code: "zhongtongkuaiyun" },
      { name: "安能快运", code: "annengwuliu" },
      { name: "顺丰快运", code: "shunfengkuaiyun" },
      { name: "韵达快运", code: "yundakuaiyun" },
      { name: "跨越速运", code: "kuayue" },
      { name: "京东快运", code: "jingdongkuaiyun" },
      { name: "百世快运", code: "baishiwuliu" },
      { name: "菜鸟速递", code: "cainiaozhisong" },
    ],
    num: ""
  },
  expressComNames() {
    return this.data.expressComs.map(el => el.name)
  },
  pickExpressCom(e) {
    this.setData({
      currentExpressComIndex: e.detail.value
    })
    this.getExpressData()
  },

  // 获取物流信息
  getExpressData() {
    getExpressDetail({
      num: this.data.num,
      com: this.data.expressComs[this.data.currentExpressComIndex].code,
      success: (res) => {
        if (res.data.status === "200") {
          console.log(res.data.data);
          this.setData({
            records: res.data.data
          })
        } else {
          this.setData({
            records: []
          }),
            wx.showToast({
              icon: "error",
              title: res.data.message,
            })
        }
      }
    })
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    const { logisticsNum, logisticsName } = options
    const index = this.data.expressComs.findIndex(el => el.name === logisticsName)
    this.setData({
      num: logisticsNum,
      currentExpressComIndex: index < 0 ? 0 : index
    })
    this.getExpressData()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})