// pages/my/my_address/my_address_details/my_address_details.js
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    region: ['', '', ''],
    default: true,
    name: '',
    phone: '',
    addr: '',
    id: '',
    version: 0,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options.id) {
      wx.setNavigationBarTitle({
        title: '编辑地址',
      })
      wx.showLoading({
        title: '加载中',
      })
      wx.request({
        url: app.globalData.ip + '/wisdommining/api/user/getUserAddressDetail',
        method: 'GET',
        header: {
          "content-type": "application/x-www-form-urlencoded",
        },
        data: {
          id: options.id,
        },
        success: res => {
          console.log(res)
          wx.hideLoading()
          if (res.data.code == 1) {
            var data = res.data.value;
            this.setData({
              id: options.id,
              name: data.addressName,
              addr: data.addressDetailed,
              phone: data.addressPhone,
              region: [data.addressProvince, data.addressCity, data.addressArea],
              default: data.addressDefault == 1 ? true : false,
            })
          } else {
            wx.showModal({
              title: '提示!',
              content: res.data.message,
              showCancel: false,
            })
          }
        }
      })
    }
  },
  //默认
  default: function (e) {
    this.setData({
      default: !this.data.default
    })
  },
  //选择地址
  bindRegionChange: function (e) {
    console.log('picker发送选择改变，携带值为', e.detail.value)
    this.setData({
      region: e.detail.value
    })
  },
  //新增 保存
  add: function (e) {
    var phone = this.data.phone;
    var name = this.data.name;
    var addr = this.data.addr;
    var region = this.data.region;
    if (phone == '' || phone.length != 11) {
      wx.showToast({
        title: '请输入正确的手机号~',
        icon: 'none'
      })
      return
    }
    if (name == '') {
      wx.showToast({
        title: '请输入姓名~',
        icon: 'none'
      })
      return
    }
    if (region[0] == '') {
      wx.showToast({
        title: '请选择地址~',
        icon: 'none'
      })
      return
    }
    if (addr == '') {
      wx.showToast({
        title: '请输入街道地址~',
        icon: 'none'
      })
      return
    }
    wx.showLoading({
      title: '加载中',
    })
    wx.request({
      url: app.globalData.ip + '/wisdommining/api/user/addUserAddress',
      method: 'POST',
      data: {
        id:parseInt(this.data.id),
        addressName: name,
        addressPhone: phone,
        addressProvince: region[0],
        addressCity: region[1],
        addressArea: region[2],
        addressDetailed: addr,
        addressDefault: this.data.default ? 1 : 0,
        wxuserId:app.globalData.userId,
      },
      success: res => {
        console.log(res)
        wx.hideLoading()
        if (res.data.code == 1) {
          wx.showToast({
            title: this.data.id == '' ? '添加成功~' : '修改成功~',
            icon: 'none',
            success: s => {
              setTimeout((t) => {
                wx.navigateBack()
              }, 1000);
            }
          })
        }else {
          wx.showModal({
            title: '提示!',
            content: res.data.message,
            showCancel: false,
          })
        }
      }
    })
  },

  name: function (e) {
    this.setData({
      name: e.detail.value
    })
  },
  phone: function (e) {
    this.setData({
      phone: e.detail.value
    })
  },
  addr: function (e) {
    this.setData({
      addr: e.detail.value
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },
})