const WxParse = require('../../wxParse/wxParse.js');
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    bgImg: app.globalData.bgImg,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    //上级id
    if (options.pId) {
      wx.setStorage({
        data: options.pId,
        key: 'pId',
      })
    }
    wx.showLoading({
      title: '加载中',
    })
    wx.request({
      url: app.globalData.ip + '/wisdommining/api/banner/getWelfareCustom',
      method: 'GET',
      header: {
        "content-type": "application/x-www-form-urlencoded",
      },
      data: {},
      success: res => {
        console.log(res)
        wx.hideLoading()
        if (res.data.code == 1) {
          WxParse.wxParse('article', 'html', res.data.value.welfarePhoto, this, 20);
        } else {
          wx.showModal({
            title: '获取数据失败!',
            content: res.data.message,
            showCancel: false,
          })
        }
      }
    })
  },

  custom(){
    wx.navigateTo({
      url: '/pages/welfareImg/welfare_tj/welfare_tj',
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
  * 用户点击右上角分享
  */
  onShareAppMessage: function () {
    app.share();
    return {
      path: '/pages/index/index?pId=' + app.globalData.userId,
      title: '三品慧采小程序等你来~'
    }
  },
})